// Author: Ben Zhang
// License: MIT

float strength = 0.6;
const float PI = 3.141592653589793;

vec4 transition(vec2 uv) {
    vec4 from = getFromColor(uv);
    vec4 to = getToColor(uv);

    // Multipliers
    float from_m = 1.0 - progress + sin(PI * progress) * strength;
    float to_m = progress + sin(PI * progress) * strength;

    return vec4(
        from.r * from.a * from_m + to.r * to.a * to_m,
        from.g * from.a * from_m + to.g * to.a * to_m,
        from.b * from.a * from_m + to.b * to.a * to_m,
        mix(from.a, to.a, progress)
    );
}